<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfIndCoverageReqsTypeLuggageItem ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfIndCoverageReqsTypeLuggageItem extends AbstractStructArrayBase
{
    /**
     * The LuggageItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgIndCoverageReqsTypeLuggageItem[]
     */
    public $LuggageItem;
    /**
     * Constructor method for ArrayOfIndCoverageReqsTypeLuggageItem
     * @uses DgArrayOfIndCoverageReqsTypeLuggageItem::setLuggageItem()
     * @param \dgsoft\StructType\DgIndCoverageReqsTypeLuggageItem[] $luggageItem
     */
    public function __construct(array $luggageItem = array())
    {
        $this
            ->setLuggageItem($luggageItem);
    }
    /**
     * Get LuggageItem value
     * @return \dgsoft\StructType\DgIndCoverageReqsTypeLuggageItem[]|null
     */
    public function getLuggageItem()
    {
        return $this->LuggageItem;
    }
    /**
     * Set LuggageItem value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgIndCoverageReqsTypeLuggageItem[] $luggageItem
     * @return \dgsoft\ArrayType\DgArrayOfIndCoverageReqsTypeLuggageItem
     */
    public function setLuggageItem(array $luggageItem = array())
    {
        foreach ($luggageItem as $arrayOfIndCoverageReqsTypeLuggageItemLuggageItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfIndCoverageReqsTypeLuggageItemLuggageItemItem instanceof \dgsoft\StructType\DgIndCoverageReqsTypeLuggageItem) {
                throw new \InvalidArgumentException(sprintf('The LuggageItem property can only contain items of \dgsoft\StructType\DgIndCoverageReqsTypeLuggageItem, "%s" given', is_object($arrayOfIndCoverageReqsTypeLuggageItemLuggageItemItem) ? get_class($arrayOfIndCoverageReqsTypeLuggageItemLuggageItemItem) : gettype($arrayOfIndCoverageReqsTypeLuggageItemLuggageItemItem)), __LINE__);
            }
        }
        $this->LuggageItem = $luggageItem;
        return $this;
    }
    /**
     * Add item to LuggageItem value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgIndCoverageReqsTypeLuggageItem $item
     * @return \dgsoft\ArrayType\DgArrayOfIndCoverageReqsTypeLuggageItem
     */
    public function addToLuggageItem(\dgsoft\StructType\DgIndCoverageReqsTypeLuggageItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgIndCoverageReqsTypeLuggageItem) {
            throw new \InvalidArgumentException(sprintf('The LuggageItem property can only contain items of \dgsoft\StructType\DgIndCoverageReqsTypeLuggageItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->LuggageItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgIndCoverageReqsTypeLuggageItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgIndCoverageReqsTypeLuggageItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgIndCoverageReqsTypeLuggageItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgIndCoverageReqsTypeLuggageItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgIndCoverageReqsTypeLuggageItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string LuggageItem
     */
    public function getAttributeName()
    {
        return 'LuggageItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfIndCoverageReqsTypeLuggageItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
